diff -ruN vdr-1.5.6/CONTRIBUTORS vdr-1.5.7/CONTRIBUTORS
--- vdr-1.5.6/CONTRIBUTORS	2007-07-22 13:34:19.000000000 +0200
+++ vdr-1.5.7/CONTRIBUTORS	2007-08-12 13:56:01.000000000 +0200
@@ -1127,6 +1127,8 @@
  with open file handles when starting background commands
  for fixing handling error status in cDvbTuner::GetFrontendStatus()
  for fixing a busy loop in fast forward if the next video data file is missing
+ for adding a debug error message to cReceiver::~cReceiver() in case it is still
+ attached to a device
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1405,6 +1407,7 @@
  for fixing handling ChannelUp/Down keys if there is currently a replay running
  for fixing a buffer overflow in initializing the system character table
  for reporting a missing 'P' in vdr.c's SHUTDOWNCANCELROMPT macro
+ for fixing a problem with characters >0x7F in the modified version of skipspace()
 
 Jürgen Schmitz <j.schmitz@web.de>
  for reporting a bug in displaying the current channel when switching via the SVDRP
@@ -1519,6 +1522,7 @@
  for making VDR actually use the iso8859-15 fonts
  for suggesting to make the function ExchangeChars()
  for reporting duplicate texts in i18n.c
+ for suggesting to use 'gettext' for internationalization
 
 Mattias Grönlund <Mattias@Gronlund.net>
  for pointing out a missing cleanup at program exit in case there is a problem
@@ -1676,6 +1680,9 @@
  for adapting cThread::ThreadId() to recent kernels
  for some improvements to the man pages
  for fixing some spelling errors in 'newplugin'
+ for suggesting to add the "...or (at your option) any later version" phrase to the
+ license information of all plugins, and also the 'newplugin' script
+ for fixing the link to the GPL2 at http://www.gnu.org in vdr.c
 
 Steffen Beyer <cpunk@reactor.de>
  for fixing setting the colored button help after deleting a recording in case the next
@@ -1793,6 +1800,8 @@
  for reporting that the cTimer::operator=() messes up the cListObject's pointers
  for reporting a memory leak in the cTimer::operator=() when using the 'aux' string
  for fixing cTimer::operator=() in case a cTimer variable is assigned to itself
+ for making the list of tracks given in cStatus::SetAudioTrack() NULL terminated
+ for fixing handling kLeft in the calls to cStatus::MsgOsdTextItem()
 
 Philip Prindeville <philipp_subx@redfish-solutions.com>
  for updates to 'sources.conf'
@@ -1919,11 +1928,13 @@
 
 Malte Schröder <MalteSch@gmx.de>
  for reporting a crash after executing the SVDRP command CLRE
+ for reporting a crash with the code for detecting Premiere NVOD channel links
 
 Markus Hahn <mhahn@reel-multimedia.com>
  for suggesting to only start recordings if there is at least 300MB free disk space
  for suggesting that the "Back" key should restore the original string when pressed
  while editing a string item
+ for fixing detection of Premiere NVOD channel links
 
 Jaroslaw Swierczynski <swiergot@gmail.com>
  for updating the Polish OSD texts and the fontosd-iso8859-2.c file
@@ -2118,3 +2129,7 @@
 Tobias Bratfisch <tobias@reel-multimedia.com>
  for improving numdigits(), isnumber() and strreplace()
  for suggesting to make skipspace() an inline function
+
+Andreas Mair <andreas@vdr-developer.org>
+ for suggesting to make cBitmap::SetXpm() checks whether the given Xpm pointer is
+ not NULL
diff -ruN vdr-1.5.6/HISTORY vdr-1.5.7/HISTORY
--- vdr-1.5.6/HISTORY	2007-07-22 13:34:35.000000000 +0200
+++ vdr-1.5.7/HISTORY	2007-08-12 13:55:41.000000000 +0200
@@ -5293,8 +5293,55 @@
 - Made skipspace() an inline function (suggested by Tobias Bratfisch) and changed
   it to handle the most common case of 'no leading space' very fast, and avoid
   calling isspace(), which made the whole function a lot faster.
-- Fixed detection of Premiere NVOD channel links (thanks to anonymous).
+- Fixed detection of Premiere NVOD channel links (thanks to Markus Hahn).
 - Added a table of the used trick speed values to the description of
   cDevice::TrickSpeed() (suggested by Martin Dauskardt).
 - Added a missing 'P' to vdr.c's SHUTDOWNCANCELROMPT macro (reported by Marco
   Schlüßler).
+
+2007-08-12: Version 1.5.7
+
+- All logging now goes to LOG_ERR, because some systems split error, info and
+  debug messages into separate files, which repeatedly caused extra efforts to
+  find out when incomplete log excerpts were attached to problem reports in
+  the past.
+- Updated the Estonian OSD texts (thanks to Arthur Konovalov).
+- Fixed a problem with characters >0x7F in the modified version of skipspace()
+  (thanks to Marco Schlüßler).
+- Fixed a bug I introduced when simplifying the original patch for detecting
+  Premiere NVOD channel links (crash reported by Malte Schröder).
+- Internationalization is now done with 'gettext' (following a suggestion by
+  Lucian Muresan). Plugin authors may want to use the Perl script
+  'i18n-to-gettext.pl' to convert their internationalized texts to the gettext
+  format (see the instructions inside that script file). The function
+  cPlugin::RegisterI18n() is still present for compatibility, but doesn't
+  have any more functionality. So plugins that don't convert their texts to
+  the gettext format will only present English texts.
+  See PLUGINS.html, section "Internationalization", for instructions on how
+  to make strings in arrays translatable.
+  See README.i18n for information on how to create new or maintain existing
+  translations.
+- The three letter language codes and their aliases are stored in i18n.c, and
+  each translation file only contains one of them to link that language name
+  to the code.
+- The 'newplugin' script has been extended to generate the Makefile section
+  for i18n support.
+- The parameter OSDLanguage in 'setup.conf' is now a string and holds the locale
+  code of the selected OSD language (e.g. en_US). If Setup.OSDLanguage is not
+  set to a particular locale that is found in VDR's locale directory, the
+  locale as defined in the system environment is used by default.
+- The list of tracks given in cStatus::SetAudioTrack() is now NULL terminated,
+  so that plugins can actually use all the strings in the list, not just the
+  one pointed to by Index (thanks to Alexander Rieger).
+- Fixed handling kLeft in the calls to cStatus::MsgOsdTextItem() (thanks to
+  Alexander Rieger).
+- Added the "...or (at your option) any later version" phrase to the license
+  information of all plugins, and also the 'newplugin' script (suggested by
+  Ville Skyttä). Plugin authors may want to consider doing the same.
+- Fixed the link to the GPL2 at http://www.gnu.org in vdr.c (thanks to Ville
+  Skyttä).
+- cBitmap::SetXpm() now checks whether the given Xpm pointer is not NULL, to
+  avoid a crash with files that only contain "/* XPM */" (suggested by Andreas
+  Mair).
+- Added a debug error message to cReceiver::~cReceiver() in case it is still
+  attached to a device (thanks to Reinhard Nissl).
diff -ruN vdr-1.5.6/INSTALL vdr-1.5.7/INSTALL
--- vdr-1.5.6/INSTALL	2007-06-16 15:55:28.000000000 +0200
+++ vdr-1.5.7/INSTALL	2007-08-10 15:32:08.000000000 +0200
@@ -24,6 +24,7 @@
 
   fontconfig
   freetype2
+  gettext
   libcap
   libjpeg
 
diff -ruN vdr-1.5.6/Make.config.template vdr-1.5.7/Make.config.template
--- vdr-1.5.6/Make.config.template	2006-06-15 11:15:25.000000000 +0200
+++ vdr-1.5.7/Make.config.template	2007-08-12 14:04:17.000000000 +0200
@@ -6,7 +6,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Make.config.template 1.10 2006/06/15 09:15:25 kls Exp $
+# $Id: Make.config.template 1.12 2007/08/12 12:04:17 kls Exp $
 
 ### The C compiler and options:
 
@@ -26,6 +26,7 @@
 #DVBDIR   = /usr/src/v4l-dvb/linux
 MANDIR   = /usr/local/man
 BINDIR   = /usr/local/bin
+LOCDIR   = /usr/share/vdr/locale  # set to ./locale to run VDR from within its source directory
 
 PLUGINDIR= ./PLUGINS
 PLUGINLIBDIR= $(PLUGINDIR)/lib
diff -ruN vdr-1.5.6/Makefile vdr-1.5.7/Makefile
--- vdr-1.5.6/Makefile	2007-06-16 12:48:59.000000000 +0200
+++ vdr-1.5.7/Makefile	2007-08-11 14:26:12.000000000 +0200
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 1.101 2007/06/16 10:48:59 kls Exp $
+# $Id: Makefile 1.102 2007/08/11 12:26:12 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -17,6 +17,7 @@
 LSIDIR   = ./libsi
 MANDIR   = /usr/local/man
 BINDIR   = /usr/local/bin
+LOCDIR   = /usr/share/vdr/locale
 LIBS     = -ljpeg -lpthread -ldl -lcap -lfreetype -lfontconfig
 INCLUDES = -I/usr/include/freetype2
 
@@ -58,6 +59,7 @@
 
 DEFINES += -DVIDEODIR=\"$(VIDEODIR)\"
 DEFINES += -DPLUGINDIR=\"$(PLUGINLIBDIR)\"
+DEFINES += -DLOCDIR=\"$(LOCDIR)\"
 
 # The version numbers of VDR and the plugin API (taken from VDR's "config.h"):
 
@@ -69,7 +71,7 @@
 DEFINES += -DVFAT
 endif
 
-all: vdr
+all: vdr i18n
 
 # Implicit rules:
 
@@ -95,6 +97,35 @@
 $(SILIB):
 	$(MAKE) -C $(LSIDIR) all
 
+# Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmo    = $(addsuffix .mo, $(foreach file, $(I18Npo), $(basename $(file))))
+I18Ndirs  = $(notdir $(foreach file, $(I18Npo), $(basename $(file))))
+I18Npot   = $(PODIR)/vdr.pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
+
+$(I18Npo): $(I18Npot)
+	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+
+i18n: $(I18Nmo)
+	@mkdir -p $(LOCALEDIR)
+	for i in $(I18Ndirs); do\
+	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
+	    cp $(PODIR)/$$i.mo $(LOCALEDIR)/$$i/LC_MESSAGES/vdr.mo;\
+	    done
+
+install-i18n:
+	@mkdir -p $(LOCDIR)
+	@(cd $(LOCALEDIR); cp -r --parents * $(LOCDIR))
+
 # The 'include' directory (for plugins):
 
 include-dir:
@@ -169,6 +200,7 @@
 clean:
 	$(MAKE) -C $(LSIDIR) clean
 	-rm -f $(OBJS) $(DEPFILE) vdr core* *~
+	-rm -rf $(LOCALEDIR) $(PODIR)/*.mo $(PODIR)/*.pot
 	-rm -rf include
 	-rm -rf srcdoc
 CLEAN: clean
diff -ruN vdr-1.5.6/PLUGINS/src/hello/HISTORY vdr-1.5.7/PLUGINS/src/hello/HISTORY
--- vdr-1.5.6/PLUGINS/src/hello/HISTORY	2006-04-22 11:32:30.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/hello/HISTORY	2007-08-10 16:02:15.000000000 +0200
@@ -49,3 +49,7 @@
 2006-04-22: Version 0.1.1
 
 - Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+
+2007-08-11: Version 0.2.0
+
+- Switched to 'gettext' internationalization.
diff -ruN vdr-1.5.6/PLUGINS/src/hello/Makefile vdr-1.5.7/PLUGINS/src/hello/Makefile
--- vdr-1.5.6/PLUGINS/src/hello/Makefile	2006-09-09 14:38:35.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/hello/Makefile	2007-08-11 12:18:16.000000000 +0200
@@ -1,11 +1,13 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.15 2006/09/09 12:38:35 kls Exp $
+# $Id: Makefile 1.16 2007/08/11 10:18:16 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
 # By default the main source file also carries this name.
+# IMPORTANT: the presence of this macro is important for the Make.config
+# file. So it must be defined, even if it is not used here!
 #
 PLUGIN = hello
 
@@ -45,25 +47,50 @@
 
 ### The object files (add further files here):
 
-OBJS = $(PLUGIN).o i18n.o
+OBJS = $(PLUGIN).o
 
 ### Implicit rules:
 
 %.o: %.c
 	$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
 
-# Dependencies:
+### Dependencies:
 
-MAKEDEP = g++ -MM -MG
+MAKEDEP = $(CXX) -MM -MG
 DEPFILE = .dependencies
 $(DEPFILE): Makefile
 	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
 
 -include $(DEPFILE)
 
+### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmo    = $(addsuffix .mo, $(foreach file, $(I18Npo), $(basename $(file))))
+I18Ndirs  = $(notdir $(foreach file, $(I18Npo), $(basename $(file))))
+I18Npot   = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
+
+$(I18Npo): $(I18Npot)
+	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+
+i18n: $(I18Nmo)
+	@mkdir -p $(LOCALEDIR)
+	for i in $(I18Ndirs); do\
+	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
+	    cp $(PODIR)/$$i.mo $(LOCALEDIR)/$$i/LC_MESSAGES/$(PLUGIN).mo;\
+	    done
+
 ### Targets:
 
-all: libvdr-$(PLUGIN).so
+all: libvdr-$(PLUGIN).so i18n
 
 libvdr-$(PLUGIN).so: $(OBJS)
 	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
@@ -78,4 +105,5 @@
 	@echo Distribution package created as $(PACKAGE).tgz
 
 clean:
+	@-rm -f $(PODIR)/*.mo $(PODIR)/*.pot
 	@-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~
diff -ruN vdr-1.5.6/PLUGINS/src/hello/README vdr-1.5.7/PLUGINS/src/hello/README
--- vdr-1.5.6/PLUGINS/src/hello/README	2002-05-09 15:47:55.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/hello/README	2007-08-12 13:07:37.000000000 +0200
@@ -6,6 +6,10 @@
 
 Latest version available at: www.cadsoft.de/people/kls/vdr/software.htm
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description: This is a small demo of the VDR plugin interface.
diff -ruN vdr-1.5.6/PLUGINS/src/hello/hello.c vdr-1.5.7/PLUGINS/src/hello/hello.c
--- vdr-1.5.6/PLUGINS/src/hello/hello.c	2006-04-22 11:31:52.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/hello/hello.c	2007-08-11 11:31:17.000000000 +0200
@@ -3,18 +3,18 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hello.c 1.12 2006/04/22 09:31:52 kls Exp $
+ * $Id: hello.c 1.13 2007/08/11 09:31:17 kls Exp $
  */
 
 #include <getopt.h>
 #include <stdlib.h>
+#include <vdr/i18n.h>
 #include <vdr/interface.h>
 #include <vdr/plugin.h>
-#include "i18n.h"
 
-static const char *VERSION        = "0.1.1";
-static const char *DESCRIPTION    = "A friendly greeting";
-static const char *MAINMENUENTRY  = "Hello";
+static const char *VERSION        = "0.2.0";
+static const char *DESCRIPTION    = trNOOP("A friendly greeting");
+static const char *MAINMENUENTRY  = trNOOP("Hello");
 
 class cPluginHello : public cPlugin {
 private:
@@ -115,7 +115,6 @@
 bool cPluginHello::Start(void)
 {
   // Start any background activities the plugin shall perform.
-  RegisterI18n(Phrases);
   return true;
 }
 
diff -ruN vdr-1.5.6/PLUGINS/src/osddemo/README vdr-1.5.7/PLUGINS/src/osddemo/README
--- vdr-1.5.6/PLUGINS/src/osddemo/README	2002-11-23 17:10:59.000000000 +0100
+++ vdr-1.5.7/PLUGINS/src/osddemo/README	2007-08-12 13:08:12.000000000 +0200
@@ -6,7 +6,11 @@
 
 Latest version available at: http://www.cadsoft.de/vdr
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 
diff -ruN vdr-1.5.6/PLUGINS/src/servicedemo/README vdr-1.5.7/PLUGINS/src/servicedemo/README
--- vdr-1.5.6/PLUGINS/src/servicedemo/README	2005-08-21 12:43:50.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/servicedemo/README	2007-08-12 13:08:15.000000000 +0200
@@ -6,7 +6,11 @@
 
 Latest version available at: www.cadsoft.de/vdr
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 
diff -ruN vdr-1.5.6/PLUGINS/src/skincurses/README vdr-1.5.7/PLUGINS/src/skincurses/README
--- vdr-1.5.6/PLUGINS/src/skincurses/README	2005-10-01 14:19:49.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/skincurses/README	2007-08-12 13:08:16.000000000 +0200
@@ -6,7 +6,11 @@
 
 Latest version available at: www.cadsoft.de/vdr
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 
diff -ruN vdr-1.5.6/PLUGINS/src/sky/README vdr-1.5.7/PLUGINS/src/sky/README
--- vdr-1.5.6/PLUGINS/src/sky/README	2004-02-15 13:39:19.000000000 +0100
+++ vdr-1.5.7/PLUGINS/src/sky/README	2007-08-12 13:08:16.000000000 +0200
@@ -6,7 +6,11 @@
 
 Latest version available at: www.cadsoft.de/vdr
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 
diff -ruN vdr-1.5.6/PLUGINS/src/status/README vdr-1.5.7/PLUGINS/src/status/README
--- vdr-1.5.6/PLUGINS/src/status/README	2002-06-16 15:43:41.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/status/README	2007-08-12 13:08:17.000000000 +0200
@@ -6,6 +6,10 @@
 
 Latest version available at: www.cadsoft.de/people/kls/vdr/software.htm
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description: This is an example that shows the use of cStatus.
diff -ruN vdr-1.5.6/PLUGINS/src/svdrpdemo/README vdr-1.5.7/PLUGINS/src/svdrpdemo/README
--- vdr-1.5.6/PLUGINS/src/svdrpdemo/README	2005-08-27 13:29:10.000000000 +0200
+++ vdr-1.5.7/PLUGINS/src/svdrpdemo/README	2007-08-12 13:08:18.000000000 +0200
@@ -6,7 +6,11 @@
 
 Latest version available at: http://www.cadsoft.de/vdr
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 
diff -ruN vdr-1.5.6/README.i18n vdr-1.5.7/README.i18n
--- vdr-1.5.6/README.i18n	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.7/README.i18n	2007-08-11 13:28:42.000000000 +0200
@@ -0,0 +1,42 @@
+Video Disk Recorder ('VDR') - Internationalization
+--------------------------------------------------
+
+The internationalized texts of VDR and its plugins use the 'gettext'
+functionality. This file provides information on how to maintain
+these texts. The instructions apply equally to VDR itself or any
+plugin.
+
+
+How to translate to a new language
+----------------------------------
+
+- Change into the source directory.
+- Do a 'make i18n' to have the current *.pot file created.
+- Make sure your locale is set to the language you want to
+  translate to.
+- Change into the 'po' subdirectory and run 'msginit'. This
+  will create a new *.po file for your language.
+- Edit the new *.po file and translate the texts.
+  You can do this either with your favorite text editor, or
+  with a specialited tool like POEdit, GTranslator, KBabel
+  or whatever you have.
+
+How to maintain an existing language file
+-----------------------------------------
+
+- Do a 'make i18n' to have the *.po files brought up-to-date
+  with the texts in the source code.
+- Edit the new *.po file and translate the texts.
+  If you are using a plain text editor, you should search for
+  empty strings ("") to find new, untranslated texts. Also,
+  look for the "fuzzy" keyword to find translations that have
+  been "guessed" from other, similar texts, and make sure they
+  are correct. After that you may want to remove the "fuzzy"
+  keyword. Specialized tools for maintaining translation
+  files may provide particular functions to guide you through
+  updating translations.
+
+Once you have created or updated a translation file, please
+send it to the maintainer of the respective plugin (in case
+it belongs to a plugin) or to kls@cadsoft.de (for core VDR
+language files).
diff -ruN vdr-1.5.6/config.c vdr-1.5.7/config.c
--- vdr-1.5.6/config.c	2007-06-23 11:42:49.000000000 +0200
+++ vdr-1.5.7/config.c	2007-08-12 14:09:37.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 1.154 2007/06/23 09:42:49 kls Exp $
+ * $Id: config.c 1.156 2007/08/12 12:09:37 kls Exp $
  */
 
 #include "config.h"
@@ -214,7 +214,7 @@
 
 cSetup::cSetup(void)
 {
-  OSDLanguage = 0;
+  strcpy(OSDLanguage, ""); // default is taken from environment
   strcpy(OSDSkin, "sttng");
   strcpy(OSDTheme, "default");
   PrimaryDVB = 1;
@@ -349,9 +349,9 @@
 
 void cSetup::StoreLanguages(const char *Name, int *Values)
 {
-  char buffer[I18nNumLanguages * 4];
+  char buffer[I18nLanguages()->Size() * 4];
   char *q = buffer;
-  for (int i = 0; i < I18nNumLanguages; i++) {
+  for (int i = 0; i < I18nLanguages()->Size(); i++) {
       if (Values[i] < 0)
          break;
       const char *s = I18nLanguageCode(Values[i]);
@@ -369,7 +369,7 @@
 bool cSetup::ParseLanguages(const char *Value, int *Values)
 {
   int n = 0;
-  while (Value && *Value && n < I18nNumLanguages) {
+  while (Value && *Value && n < I18nLanguages()->Size()) {
         char buffer[4];
         strn0cpy(buffer, Value, sizeof(buffer));
         int i = I18nLanguageIndex(buffer);
@@ -384,7 +384,7 @@
 
 bool cSetup::Parse(const char *Name, const char *Value)
 {
-  if      (!strcasecmp(Name, "OSDLanguage"))         OSDLanguage        = atoi(Value);
+  if      (!strcasecmp(Name, "OSDLanguage"))       { strn0cpy(OSDLanguage, Value, sizeof(OSDLanguage)); I18nSetLocale(OSDLanguage); }
   else if (!strcasecmp(Name, "OSDSkin"))             Utf8Strn0Cpy(OSDSkin, Value, MaxSkinName);
   else if (!strcasecmp(Name, "OSDTheme"))            Utf8Strn0Cpy(OSDTheme, Value, MaxThemeName);
   else if (!strcasecmp(Name, "PrimaryDVB"))          PrimaryDVB         = atoi(Value);
diff -ruN vdr-1.5.6/config.h vdr-1.5.7/config.h
--- vdr-1.5.6/config.h	2007-07-20 16:52:05.000000000 +0200
+++ vdr-1.5.7/config.h	2007-08-10 15:01:52.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.294 2007/07/20 14:52:05 kls Exp $
+ * $Id: config.h 1.296 2007/08/10 13:01:52 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.5.6"
-#define VDRVERSNUM   10506  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.5.7"
+#define VDRVERSNUM   10507  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.5.6"
-#define APIVERSNUM   10506  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.5.7"
+#define APIVERSNUM   10507  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -199,7 +199,7 @@
 public:
   // Also adjust cMenuSetup (menu.c) when adding parameters here!
   int __BeginData__;
-  int OSDLanguage;
+  char OSDLanguage[I18N_MAX_LOCALE_LEN];
   char OSDSkin[MaxSkinName];
   char OSDTheme[MaxThemeName];
   int PrimaryDVB;
@@ -219,8 +219,8 @@
   int TimeSource;
   int TimeTransponder;
   int MarginStart, MarginStop;
-  int AudioLanguages[I18nNumLanguages + 1];
-  int EPGLanguages[I18nNumLanguages + 1];
+  int AudioLanguages[I18N_MAX_LANGUAGES + 1];
+  int EPGLanguages[I18N_MAX_LANGUAGES + 1];
   int EPGScanTimeout;
   int EPGBugfixLevel;
   int EPGLinger;
diff -ruN vdr-1.5.6/eit.c vdr-1.5.7/eit.c
--- vdr-1.5.6/eit.c	2007-07-21 16:58:04.000000000 +0200
+++ vdr-1.5.7/eit.c	2007-07-28 15:16:43.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 1.124 2007/07/21 14:58:04 kls Exp $
+ * $Id: eit.c 1.125 2007/07/28 13:16:43 kls Exp $
  */
 
 #include "eit.h"
@@ -199,7 +199,7 @@
                           else if (Setup.UpdateChannels >= 4) {
                              cChannel *transponder = channel;
                              if (channel->Tid() != ld->getTransportStreamId())
-                                channel = Channels.GetByTransponderID(linkID);
+                                transponder = Channels.GetByTransponderID(linkID);
                              link = Channels.NewChannel(transponder, linkName, "", "", ld->getOriginalNetworkId(), ld->getTransportStreamId(), ld->getServiceId());
                              //XXX patFilter->Trigger();
                              }
